unit uBizAlbaranClienteServer;

interface

uses
  schFacturasClienteServer_Intf, uDAInterfaces,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_ALBARAN_CLIENTE = 'Server.AlbaranCliente';
  REF_ALBARANES_CLIENTE = 'REF_ALBARANES_CLIENTE';
  REF_ALBARANES_DEV_CLIENTE = 'REF_ALBARANES_DEV_CLIENTE';

type
  TBizAlbaranClienteServer = class(TFacturasClienteBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  Dialogs, SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schAlbaranesClienteClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizFacturasClienteServer }

procedure TBizAlbaranClienteServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;
  CodigoReferencia: String;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_AlbaranesClienteREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_AlbaranesClienteREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_AlbaranesClienteID_EMPRESA];
          if (aChange.NewValueByName[fld_AlbaranesClienteIMPORTE_TOTAL] < 0) then
             CodigoReferencia := REF_ALBARANES_DEV_CLIENTE
          else
             CodigoReferencia := REF_ALBARANES_CLIENTE;

          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'ID_EMPRESA'], [CodigoReferencia, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + CodigoReferencia + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName(fld_DarReferenciaVALOR).AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'ID_EMPRESA'], [CodigoReferencia, DarReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_ALBARAN_CLIENTE, TBizAlbaranClienteServer);

end.
